Bug 1321963 - Review Request: ghc-pipes-safe - Safety for the pipes ecosystem
Summary: Review Request: ghc-pipes-safe - Safety for the pipes ecosystem
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jaroslav Škarvada
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-03-29 13:27 UTC by Jan Synacek
Modified: 2016-04-08 17:02 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-04-08 17:02:00 UTC
jskarvad: fedora-review+


Attachments (Terms of Use)

Description Jan Synacek 2016-03-29 13:27:48 UTC
Spec URL: https://jsynacek.fedorapeople.org/ghc-pipes-safe/ghc-pipes-safe.spec
SRPM URL: https://jsynacek.fedorapeople.org/ghc-pipes-safe/ghc-pipes-safe-2.2.2-1.fc24.src.rpm

Description:
This package adds resource management and exception handling to the 'pipes'
ecosystem.

Notable features include:

* /Resource Safety/: Guarantee finalization using 'finally', 'bracket' and more
* /Exception Safety/: Even against asynchronous exceptions!
* /Laziness/: Only acquire resources when you need them
* /Promptness/: Finalize resources early when you are done with them
* /Native Exception Handling/: Catch and resume from exceptions inside pipes
* /No Buy-in/: Mix resource-safe pipes with unmanaged pipes using 'hoist'.

Fedora Account System Username: jsynacek

Comment 1 Jaroslav Škarvada 2016-03-30 13:08:30 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
Haskell packaging guidelines applies, so it is probably OK.

[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "BSD (3 clause)", "Unknown or generated". 5 files have unknown
     license. Detailed output of licensecheck in /home/yarda/git-fedora
     /ghc-pipes-safe/review-ghc-pipes-safe/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[-]: %build honors applicable compiler flags or justifies otherwise.
Haskell packaging guidelines apply.

[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Useful -debuginfo package or justification otherwise.
Haskell packaging guidelines applies.

[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 225280 bytes in 20 files.
[x]: Package complies to the Packaging Guidelines
It seems it mostly complies with the Haskell packaging guidelines.

[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
     Note: Found : Packager: Jaroslav Škarvada <jskarvad@redhat.com>
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags
False positive

[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
Untested.

[!]: Latest version is packaged.
2.2.3 is the latest version, but according to the packager it has unresolved deps, so probably OK.

[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[?]: Packages should try to preserve timestamps of original installed
     files.
I have really no idea what the haskell macros do, but hopefully they do what is needed.

[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: ghc-pipes-safe-2.2.2-1.fc22.x86_64.rpm
          ghc-pipes-safe-devel-2.2.2-1.fc22.x86_64.rpm
          ghc-pipes-safe-2.2.2-1.fc22.src.rpm
ghc-pipes-safe.x86_64: W: spelling-error %description -l en_US unmanaged -> unman aged, unman-aged, managed
ghc-pipes-safe.x86_64: W: no-documentation
ghc-pipes-safe.src: W: spelling-error %description -l en_US unmanaged -> unman aged, unman-aged, managed
3 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
ghc-pipes-safe.x86_64: W: spelling-error %description -l en_US unmanaged -> unman aged, unman-aged, managed
ghc-pipes-safe.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 2 warnings.



Requires
--------
ghc-pipes-safe (rpmlib, GLIBC filtered):
    ghc(base-4.7.0.2-cb23b5265b6e147094c0cd9ac819acb1)
    ghc(containers-0.5.5.1-d7910f1cd81272c1f31ca9f71d0f206e)
    ghc(exceptions-0.6.1-7fb6fec54ce5f76170ef358fff376c11)
    ghc(pipes-4.1.4-5b10aba0ff0f9096fb2801fe891155c5)
    ghc(transformers-0.3.0.0-6458c21515cab7c1cf21e53141557a1c)
    libHSarray-0.5.0.0-ghc7.8.4.so()(64bit)
    libHSbase-4.7.0.2-ghc7.8.4.so()(64bit)
    libHScontainers-0.5.5.1-ghc7.8.4.so()(64bit)
    libHSdeepseq-1.3.0.2-ghc7.8.4.so()(64bit)
    libHSexceptions-0.6.1-ghc7.8.4.so()(64bit)
    libHSghc-prim-0.3.1.0-ghc7.8.4.so()(64bit)
    libHSinteger-gmp-0.5.1.0-ghc7.8.4.so()(64bit)
    libHSmmorph-1.0.4-ghc7.8.4.so()(64bit)
    libHSmtl-2.1.3.1-ghc7.8.4.so()(64bit)
    libHSpipes-4.1.4-ghc7.8.4.so()(64bit)
    libHStransformers-0.3.0.0-ghc7.8.4.so()(64bit)
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    rtld(GNU_HASH)

ghc-pipes-safe-devel (rpmlib, GLIBC filtered):
    /bin/sh
    ghc(pipes-safe-2.2.2-4202490ce9084a16336de53c6a905d31)
    ghc-compiler
    ghc-devel(base-4.7.0.2-cb23b5265b6e147094c0cd9ac819acb1)
    ghc-devel(containers-0.5.5.1-d7910f1cd81272c1f31ca9f71d0f206e)
    ghc-devel(exceptions-0.6.1-7fb6fec54ce5f76170ef358fff376c11)
    ghc-devel(pipes-4.1.4-5b10aba0ff0f9096fb2801fe891155c5)
    ghc-devel(transformers-0.3.0.0-6458c21515cab7c1cf21e53141557a1c)
    ghc-pipes-safe(x86-64)



Provides
--------
ghc-pipes-safe:
    ghc(pipes-safe-2.2.2-4202490ce9084a16336de53c6a905d31)
    ghc-pipes-safe
    ghc-pipes-safe(x86-64)
    libHSpipes-safe-2.2.2-ghc7.8.4.so()(64bit)

ghc-pipes-safe-devel:
    ghc-devel(pipes-safe-2.2.2-4202490ce9084a16336de53c6a905d31)
    ghc-pipes-safe-devel
    ghc-pipes-safe-devel(x86-64)
    ghc-pipes-safe-static



Unversioned so-files
--------------------
ghc-pipes-safe: /usr/lib64/ghc-7.8.4/pipes-safe-2.2.2/libHSpipes-safe-2.2.2-ghc7.8.4.so

Source checksums
----------------
https://hackage.haskell.org/package/pipes-safe-2.2.2/pipes-safe-2.2.2.tar.gz :
  CHECKSUM(SHA256) this package     : 05548546c63521aacec35a952e03c748df6251ff188bde292d8e4dc20b77e0ea
  CHECKSUM(SHA256) upstream package : 05548546c63521aacec35a952e03c748df6251ff188bde292d8e4dc20b77e0ea


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -n ghc-pipes-safe
Buildroot used: fedora-22-x86_64
Active plugins: Generic, Haskell, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 2 Gwyn Ciesla 2016-04-01 18:03:56 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/ghc-pipes-safe

Comment 3 Fedora Update System 2016-04-04 07:42:45 UTC
ghc-pipes-safe-2.2.2-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-c5dfd00d1d

Comment 4 Fedora Update System 2016-04-04 19:22:45 UTC
ghc-pipes-safe-2.2.2-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-c5dfd00d1d

Comment 5 Fedora Update System 2016-04-08 17:01:58 UTC
ghc-pipes-safe-2.2.2-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.